C LEVEL 50      PROGRAM CCSL
      PROGRAM CCSL
C
C *** CCSL by JCM updated 7 Sep 92 ***
C
C ***************************************************************************
C
C                    C     C     S     L
C
C
C PROGRAM TO BE RUN ON A CCSL MASTER FILE IN ORDER TO MAKE FILES TO PRESENT TO
C A FORTRAN COMPILER;  ALSO TO EXTRACT INDIVIDUAL ROUTINES OR PROGRAMS
C AND (ONE DAY WHEN I HAVE TIME) TO INSERT OR REPLACE NEW OR IMPRPROVED ROUTINES
C
C THE PROGRAM ALSO MASQUERADES UNDER THE NAMES "GET" AND "SPLIT".
C
C "GET" IS CCSL WITH THE LOGICAL SPECIF SET TO BE TRUE
C "SPLIT" IS CCSL WITH THE LOGICAL SPLIT SET TO BE TRUE
C
C BOTH "GET" AND "SPLIT" PERFORM FUNCTIONS USEFUL IN SPECIFIC WAYS TO THE WORLD
C AT LARGE.
C
C "GET" GIVES THE USER A SUBSET OF THE GENERAL CCSL QUESTIONS, SO
C THAT HE MAY EXTRACT A ROUTINE FROM THE .FOR VERSION OF A LIBRARY FILE -
C IN FACT FROM xxxMK4.FOR IN THE SPACE IN WHICH HE IS WORKING.
C HE IS ASKED FOR THE xxx AND THE ROUTINE NAME, AND
C IS ALLOWED TO EXTRACT MORE THAN ONE ROUTINE.  THE EXTRACTED FILES WILL BE 
C CALLED <ROUTINE>.GOT.
C
C "SPLIT" MAKES INDIVIDUAL FILES FROM THE ROUTINES OF A LIBRARY.  THE SPLIT
C FILES WILL BE CALLED <ROUTINE>.SPL
C **************************************************************************
C
C THIS PROGRAM USED TO EXIST IN TWO FORMS, A MASTER FILE AND A FORTRAN
C FILE, IN THE SAME WAY THAT THE REST OF THE CCSL LIBRARY DOES.
C
C FOR SIMPLICITY IT HAS BEEN REDUCED TO A FORTRAN FILE, IN, THEREFORE
C STANDARD FORTRAN 77.  THIS HAS INVOLVED THE LOSS OF THE VAX FORTRAN EXTENSION
C "$" IN THE FORMAT STATEMENT, WHICH RESULTS IN THE INTERACTIVE I/O
C NOT LOOKING SO NICE.  I'M SORRY.
C
C FOR THE REST OF THE SYSTEM (I.E. THE FILES INPUT TO THIS PROGRAM):
C A MASTER FILE MUST BE EDITED BEFORE BEING GIVEN TO A FORTRAN COMPILER.
C A FORTRAN FILE MUST BE EDITED BEFORE BEING TREATED AS A MASTER FILE,
C FOR EXAMPLE TO BE SENT TO ANOTHER COMPUTER.
C
C IF THE COMPUTER YOU WISH TO COMPILE THE FORTRAN ON IS <COMP>, AND
C <OTHER> REPRESENTS ANY OTHER COMPUTER NAME, THEN THE EDITS ARE:
C
C MASTER TO FORTRAN - FIND EVERY LINE STARTING C<COMP> AND INSERT
C NEWLINE AFTER <COMP> - FIND EVERY LINE STARTING C-<OTHER> AND INSERT
C NEWLINE AFTER <OTHER>
C
C FORTRAN TO MASTER - REVERSE THE PROCESS, REMOVING THE NEWLINES.
C
C THE VOCABULARY FOR <COMP> COMES FROM:
C       3084     VMS ILL RAL
C
C THEN, PARAMETERS SUCH AS %ABCD% MUST BE SUSTITUTED BY THEIR VALUES
C AND ALL THE COMMON WHICH IS LISTED AS /CNAME/ MUST BE REPLACED BY WHAT
C SHOULD ACTUALLY BE THERE.
C
C VALUES FOR PARAMETERS, AND FULL COMMON LISTINGS ARE FOUND AT THE START OF
C A MISTRE.SS FILE, OR, ON SOME MACHINES, IN A SEPARATE FILE HEADER.SS.
C
C YOUR FORTRAN 77 COMPILER SHOULD BE APPLIED TO THE FORTRAN VERSION.
C
      DIMENSION NOPSY(4)
      PARAMETER (NPARS=200,NCOMM=150,NCLIN=7)
      CHARACTER *40 FILNAM,FIL1,MASFIL,SHUFLE,HEDFIL
      CHARACTER *100 FORMA
      CHARACTER *1 IN,CHR
      CHARACTER *4 PARAL1(NPARS)
      CHARACTER *6 PARAL2(NPARS)
      CHARACTER *62 MESS62
      CHARACTER *3 PART3,PARIN,VERS,VERJCM,FOR
      CHARACTER *100 PATH
      CHARACTER *6 COMP6,ROUNAM,OPSY6(4),PROG
      CHARACTER *80 LINE80
      CHARACTER *2 NLEV
      LOGICAL WANT,INTER,NOTNEW,ALTER,FOUND,WORDY,FIRST,WOUND,SEPHED
      LOGICAL SPECIF,FIRNEX,SPLIT,UNIX
      COMMON /COMSUB/NCOMS,NCLINE(NCOMM)
      COMMON /COMSUC/CNAME(NCOMM),CTEXT(NCOMM,NCLIN)
      CHARACTER *6 CNAME
      CHARACTER *80 CTEXT
      COMMON /IOUNIT/ITO,ITI
      COMMON /SYSTYM/MANU,MACH,MON3,EXTEN,EXTIN
      CHARACTER *4 MANU,MACH
      CHARACTER *3 MON3,EXTEN,EXTIN
      COMMON /PARSUB/NSUBS,NSUB1(NPARS),NSUB2(NPARS)
      COMMON /PARSUC/SUBS1(NPARS),SUBS2(NPARS)
      CHARACTER *6 SUBS1,SUBS2
      CHARACTER *1 UPLET(26)
      DATA UPLET/'A','B','C','D','E','F','G','H','I','J','K','L',
     1'M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/
C
C ***********************************
C
C SECTION TO ALTER FOR A NEW MACHINE : THIS IS NOT NOW DONE AUTOMATICALLY
C SO THAT A REALLY NEW USER DOES NOT NEED ANY INITIAL PROGRAMS ALREADY
C WORKING.  NEW USERS TO DECIDE THE FOLLOWING:
C
C FIRST, WHAT TYPE OF COMPUTER ARE YOU RUNNING THIS PROGRAM ON? AS ANSWER,
C ADJUST THE DATA STATEMENT HERE TO GIVE YOUR MACHINE, FROM THE VOCABULARY
C WHICH FOLLOWS:
      DATA COMP6/'CILL'/
*      'CRAL'
*      'C3084'
*      'CILL'
*** The next three lines are for UNIX *****
      DATA OPSY6,NOPSY,NOPT,NOPSYS/'CUNIX ','CVMS  ',' ',' ',
     &     5,4,0,0,
     &     2,3/
*** The next three lines are for VMS *****
*      DATA OPSY6,NOPSY,NOPT,NOPSYS/'CVMSO ','CVMS  ',' ',' ',
*     &     5,4,0,0,
*     &     2,1/
*      'CVMS'     VMS extensions to F77
*      'C3084'    IBM 3084 specials
*      'CVMSO'    VMS only
*      'CUNIX'    UNIX only
* NOPSYS should be 1 for VMS and 3 for UNIX
C
C ********** AND IF YOU ARE RUNNING ON AN IBM MACHINE (3084),
C            PLEASE GO NEXT TO SUBROUTINE OPFILE, AND ENSURE THAT THE
C            INSTRUCTIONS ABOUT "OPEN" STATEMENTS ARE CARRIED OUT
C            THE OTHER STATEMENTS ON OPFILE APPEAR
C            TO BE NECESSARY ON VAX BUT WILL NOT COMPILE ON IBM.
C            IF YOUR COMPUTER HAS ANY MORE FUNNY QUIRKS ABOUT OPENING
C            FILES YOU SHOULD BE ABLE TO SORT THEM OUT IN OPFILE.
C **********
C
C
C OPERATING SYSTEM
      UNIX=(NOPSYS.EQ.3)
C SET DEFAULT EXTENSIONS FOR FORTRAN FILES ETC
      FOR='FOR'
      IF (UNIX) FOR='f'
C ITO IS THE NUMBER OF THE UNIT FOR WRITING TO TELETYPE INTERACTIVELY
C ITI IS THE NUMBER OF THE UNIT FOR READING FROM TELETYPE INTERACTIVELY
      ITO=6
      ITI=5
C OPEN THE FILE CREATED BY THE GET,SPLIT  OR CCSL COMMAND
      FILNAM='CCSLDA.DAT'
      CALL UPONE(FILNAM,NOPSYS)
      CALL OPFILE(2,FILNAM,'OLD')
      READ (2,2085) PROG
 2085 FORMAT (A6)
      CALL UPONE(PROG,0)
C
C THE LOGICAL VARIABLE SPECIF IS TRUE IF THE PROGRAM HAS BEEN COMPILED
C ON A SPECIFIC COMPUTER TO DO SIMPLE EXTRACTION JOBS - IN WHICH CASE
C IT WILL BE KNOWN AS, SAY, GET.EXE (ON DEC MACHINES), AND NOT ASK
C YOU SO MANY QUESTIONS WHEN YOU RUN IT.
      SPECIF=(PROG(1:3).EQ.'GET')
C SO ***ALTER*** THE FALSE TO TRUE FOR THE SIMPLE EXTRACTION PROGRAM "GET",
C BUT BEWARE THE SPECIFIC FILE NAMES IN THE "OPEN" STATEMENTS AND
C ADJUST ACCORDINGLY.
C
C
C ****************************************************
C ALSO, SPLIT TRIGGERS THE PROGRAM WHICH SPLITS A WHOLE FILE INTO ROUTINES, ONE
C PER FILE:
      SPLIT=(PROG(1:5).EQ.'SPLIT')
      IF (SPLIT) THEN
        WRITE (ITO,2084)
2084    FORMAT (' Give 3 letters of extension for split filenames:')
        READ (ITI,1084) EXTIN
1084    FORMAT (A3)
        IF (EXTIN .EQ. ' ')  EXTIN=FOR
        WORDY=.FALSE.
C
      ELSE IF  (SPECIF) THEN
        EXTEN='GOT'
      ENDIF
      READ (2,1065) PATH
1065  FORMAT (A100)        
      IF (SPECIF .OR. SPLIT) THEN
        VERS=' '
        READ (2,1064) VERS
1064    FORMAT (A3)
        WORDY=.FALSE.
        MON3=VERS
        CALL UPONE(EXTEN,NOPSYS)
      ELSE
C
C ASK WHETHER LONG OR SHORT MESSAGES WANTED:
   3    WRITE (ITO,2080)
2080  FORMAT (' Do you want to be asked LONG questions, with',
     1' explanations'/' or SHORT questions (if you know what ',
     2'to expect?)  Type L or S : ')
        READ (ITI,1080) IN
1080  FORMAT (A1)
        CALL UPONE(IN,0)
        WORDY=(IN .EQ. 'L')
        IF (.NOT. WORDY .AND. IN .NE. 'S') GO TO 3
C
C ASK FOR <COMP>
        ICOMP=0
   4    IF (WORDY) WRITE (ITO,2056)
2056  FORMAT (/' Computer on which you want the code to be compiled',
     1' and run?  Type one of:'/'     RAL for VMS VAX at RAL'/
     2'     ILL for VMS VAX at ILL'/
     4'     3084 for IBM 3084 at Cambridge :')
        IF (.NOT. WORDY) WRITE (ITO,2006)
2006  FORMAT (' RAL ILL or 3084 : ')
        READ (ITI,1001) COMP6(2:6)
1001  FORMAT (A5)
      ENDIF
C
C CHECK <COMP> BY TRYING EACH ONE:
   9  NCOMP1=LINEND(COMP6,2,6)
      CALL UPONE(COMP6,0)
      IF (COMP6(2:4) .EQ. 'RAL') ICOMP=1
      IF (COMP6(2:5) .EQ. '3084') ICOMP=3
      IF (COMP6(2:4) .EQ. 'ILL') ICOMP=5
      IF (ICOMP .EQ. 0) GO TO 4
      MACH='XXXX'
      IF (ICOMP .EQ. 1 .OR. ICOMP .EQ. 5) MACH='VAX'
      MANU='IBM'
      IF (ICOMP .EQ. 1 .OR .ICOMP .EQ. 5) MANU='DEC'
C
C ASK FOR <PART>:
      READ (2,1064,END=312) VERS
      GO TO 313
  312 VERS=' '  
  313 CLOSE(2)
  311 IF (VERS.EQ.' ') THEN
        IF (WORDY) WRITE (ITO,2051)
        IF (.NOT. WORDY)WRITE (ITO,2001)
2001  FORMAT (' LIB, MAI, PJB, JBF, PIG, PR, PF, PMA, MPL,',
     1' or  NEW?')
2051  FORMAT (/' Which part of the Master File do you want?  Type',
     1' one of :'/'     LIB for the CCSL Library as described in Manual'/
     2'     MAI for the set of MAIN programs to accompany the LIB'/
     3'     PJB for Jane''s programs not yet in the Library'/
     4'     JBF for Bruce''s programs not yet in the Library'/
     5'     PIG for the plotting routines other than pen'/
     6'     PR for the supplementary Profile Refinement routines'/
     7'     PF for the Profile Function Library'/
     8'     PMA for the MAIN programs to accompany PR'/
     9'     MPL for the Multipole Subroutine Library'/
     +'     NEW for your own new code'/)
        READ(ITI,1002) VERS
1002  FORMAT (A3)
C
      ENDIF
      PART3=VERS
      CALL UPONE(PART3,0)
      CALL UPONE(VERS,NOPSYS)
C FOR NOW, CHECK <PART> BY TRYING EACH ONE:
      IPART=0
      IF (PART3 .EQ. 'LIB')  IPART=1
      IF (PART3 .EQ. 'PR')  IPART=2
      IF (PART3 .EQ. 'MAI')  IPART=3
      IF (PART3 .EQ. 'PIG')  IPART=4
      IF (PART3 .EQ. 'PMA')  IPART=5
      IF (PART3 .EQ. 'PJB')  IPART=6
      IF (PART3 .EQ. 'MPL')  IPART=7
      IF (PART3 .EQ. 'JBF')  IPART=8
      IF (PART3 .EQ. 'PF')  IPART=11
      IF (PART3 .EQ. 'NEW')  IPART=12
      IF (IPART .EQ. 0) THEN
        VERS=' '
        GO TO 311
      ENDIF
C
C ASK FOR REST OF FORTRAN FILE NAME: NORMALLY THE VERSION IDENTIFIER  eg MK4.
      IF (SPECIF .OR. SPLIT) GO TO 888
      IF (WORDY) WRITE(ITO,2002)
2002  FORMAT (/' "Version"? Any 3 letters to be last part',
     1' of name of file to be written')
      IF (.NOT. WORDY) WRITE (ITO,2052)
2052  FORMAT (' Version (eg MK4)?')
      READ(ITI,1002) MON3
C
      EXTEN=FOR
C MAKE VAX OR DEC FILE NAME AS <PART><MONTH>.FOR:
 888  ROUNAM(1:3)=VERS(1:3)
      J=4
      IF (IPART .EQ. 2 .OR. IPART .EQ. 11) J=3 
      J3=J+2
      CALL UPONE(MON3,NOPSYS)
      ROUNAM(J:J3)=MON3(1:3)
      CALL DOTFOR(FILNAM,ROUNAM,J3,FOR)
C
C THIS PROGRAM MAY ALSO BE USED TO EXTRACT A SINGLE ROUTINE FROM
C AN ALREADY CREATED .FOR FILE - ASK WHICH WANTED:
      NOTNEW = .FALSE.
      IF (.NOT. (SPECIF.OR. SPLIT)) THEN
      L=LENGT(FILNAM)
      WRITE (FORMA,2090) L
2090  FORMAT ('('' Type name of Master File if new file '',A',
     1I2','' must be made,''/'' or RETURN to use existing file :'')') 
      WRITE (ITO,FORMA) FILNAM 
      READ (ITI,1111) MASFIL
1111  FORMAT (A40)
      CALL UPONE(MASFIL,NOPSYS)
      IF (MASFIL .NE. ' ') GO TO 5
      ENDIF
C
C USE OLD FILE:
      NOTNEW=.TRUE.
      L=LENGT(PATH)
C UNIX
      IF (UNIX) THEN
        IF (SPECIF .OR. SPLIT) 
     &     CALL OPFILE(2,PATH(1:L)//'/'//FILNAM,'OLD')
      ELSE
C VAX
        IF (SPECIF) CALL OPFILE(2,PATH(1:L)//':'//FILNAM,'OLD')
      ENDIF
C      IF (.NOT. SPECIF) CALL OPFILE(2,FILNAM,'OLD')
      GO TO 7
C
C MAKE NEW FILE:
   5  IF (MACH .EQ. 'VAX') CALL OPFILE(2,FILNAM,'NEW')
C IBM SYSTEMS NEED "UNKNOWN" IN CASE FILE ALREADY EXISTS:
      IF (MACH .NE. 'VAX') CALL OPFILE(2,FILNAM,'UNKNOWN')
C
C START FROM THE MISTRESS FILE:
C ASK IF HEADER IN SEPARATE FILE:
      WRITE (ITO,2888)
2888  FORMAT (' Separate header file?  Type file NAME if so, or RETURN')
      READ (ITI,1111) HEDFIL
      CALL UPONE(HEDFIL,NOPSYS)
      SEPHED=(HEDFIL .NE. ' ')
      L=LENGT(PATH)
      IF (UNIX) THEN
        IF (SEPHED) CALL OPFILE(1,PATH(1:L)//'/'//HEDFIL,'OLD')
        IF (.NOT.SEPHED) CALL OPFILE(1,PATH(1:L)//'/'//MASFIL,'OLD') 
      ELSE
        IF (SEPHED) CALL OPFILE(1,PATH(1:L)//':'//HEDFIL,'OLD')
        IF (.NOT.SEPHED) CALL OPFILE(1,PATH(1:L)//':'//MASFIL,'OLD') 
      ENDIF
C
C ALWAYS COPY HEADING, AS IT STARTS WITH THE LATEST UPDATE:
   30  READ (1,5000) LINE80
5000  FORMAT (A80)
      IF (LINE80(1:4) .EQ. 'UPDT') GO TO 35
      LIND=LINEND(LINE80,1,80)
      CALL OUTLIN(2,LINE80,1,LIND)
      GO TO 30
C
C WE HAVE REACHED THE MAIN UPDATE LIST, WHICH WE DO NOT WANT TO COPY BECAUSE
C ALL THE UPDATES ARE REPEATED IN THEIR INDIVIDUAL PARTS:
  35  READ (1,5000) LINE80
      IF (LINE80(1:4) .NE. 'PARS') GO TO 35
C
C HAVE REACHED SECTION IN MISTRE.SS HEADED "PARS":
C
C COUNT PARAMETERS:
      NS=0
C
C ENQUIRE WHETHER CHANGES WANTED - THESE MAY BE INTERACTIVE OR
C ON INPUT FILE:
      IF (.NOT. WORDY) WRITE (ITO,2011)
2011  FORMAT (' Alter ANY parameters? (Y/N) :')
      IF (WORDY) WRITE (ITO,2511)
2511  FORMAT (/' The parameters which decide the array dimensions',
     1' will now be assigned.'/' If you do not change them they will',
     2' be given default values.'/' Do you want to alter ANY param',
     3'eters? (Y/N) : ')
      READ (ITI,1003) IN
1003  FORMAT (A1)
      CALL UPONE(IN,0)
      ALTER = .FALSE.
      IF (IN .EQ. 'N') GO TO 43
      ALTER = .TRUE.
      IF (WORDY) WRITE (ITO,2012)
2012  FORMAT (/' You have the choice between :'/'     being',
     1' offered each parameter interactively,'/'     with ',
     2'its present default value and a brief description,'/
     3'     with the chance to alter its ',
     3' value'/' OR'/'     of giving a file name from which',
     4' is to be read a list of'/
     5'     4-letter parameter names and 6 character new values,'/
     6'     ONE PER LINE, in FORMAT (A4,1X,A6).'//'  Type RETURN',
     7' to proceed interactively, or give file name for list : ')
      IF (.NOT. WORDY) WRITE (ITO,2512)
2512  FORMAT (' File name for list, or RETURN to interact: ')
      READ (ITI,5000) LINE80
      LIND=LINEND(LINE80,1,80)
      INTER = .TRUE.
      IF (LIND .EQ. 0) GO TO 43
C
C OPEN USER'S FILE WITH ALTERED PARAMETER LIST:
      FIL1(1:40)=LINE80(1:40)
      CALL OPFILE(4,FIL1,'OLD')
      INTER = .FALSE.
C READ IN LIST TO ALTER:
      NALTER=0
  50  NALTER=NALTER+1
      IF (NALTER .LE. NPARS) GO TO 40
      WRITE (ITO,3004) NPARS
3004  FORMAT (' More than',I5,' parameters')
      STOP
C
  40  READ (4,2020,END=43) PARAL1(NALTER),PARAL2(NALTER)
2020  FORMAT (A4,1X,A6)
      GO TO 50
C
C READ PARAMETERS, GIVING USER CHANCE TO ALTER THEM IF "ALTER":
  43  NS=NS+1
      IF (NS .LE. NPARS) GO TO 51
      WRITE (ITO,3005) NPARS
3005  FORMAT (' More than',I5,' parameters')
      STOP
C
  51  READ(1,2003) PARIN,SUBS1(NS)(2:5),SUBS2(NS)(1:6),MESS62
2003  FORMAT (A3,3X,A4,1X,A6,1X,A62)
      IF (SUBS1(NS)(2:5) .EQ. 'STOP') GO TO 44
      NSUB1(NS)=6
      SUBS1(NS)(1:1)='%'
      SUBS1(NS)(6:6)='%'
      NSUB2(NS)=LINEND(SUBS2(NS),1,6)
      IF ( .NOT. ALTER) GO TO 43
C
C ASK IF WANT TO CHANGE, UNLESS IT DEPENDS ON PREVIOUS:
      LMES=LINEND(MESS62,1,62)
      IF (LMES .NE. 0) GO TO 46
      L=0
      N=INTCHR(SUBS1(NS)(5:5),1)
      M=INTCHR(SUBS2(NS-1),6)
      CHR=SUBS1(NS-1)(4:4)
      IF (CHR .EQ. '+' .OR. CHR .EQ. '*') M=INTCHR(SUBS2(NS-2),6)
      IF (SUBS1(NS)(4:4) .EQ. '+') L=M+N
      IF (SUBS1(NS)(4:4) .EQ. '*') L=M*N
      IF (L .NE. N .AND. L .NE. 0) GO TO 48
      WRITE (ITO,3001) SUBS1(NS)(2:5),SUBS2(NS)(1:6)
3001  FORMAT (' CANNOT PROCESS PARAMETER ',A4,1X,A6)
      STOP
C
 48   CALL CHRINT(L,SUBS2(NS),1,6)
      NSUB2(NS)=LINEND(SUBS2(NS),1,6)
      GO TO 43
C
C AND PROVIDED THAT THE PARAMETER IS NOT PART-DEPENDENT, ON A PART WE ARE
C NOT DOING
  46  IF (PARIN .EQ. ' ') GO TO 68
      IF (PARIN .EQ. 'PR' .AND. PART3 .EQ. 'PF') GO TO 68
      IF (PARIN .EQ. 'PR' .AND. PART3 .EQ. 'PMA') GO TO 68
      IF (PARIN .NE. PART3) GO TO 43
  68  IF (INTER) GO TO 47
C
C FIND WHETHER THIS PARAMETER IS IN LIST TO ALTER:
      DO 61 IAL=1,NALTER
      IF (SUBS1(NS)(2:5) .EQ. PARAL1(IAL))  GO TO 49
  61  CONTINUE
      GO TO 43
C
C SUBSTITUTION NEEDED:
  49  WRITE (ITO,2008)SUBS1(NS)(2:5),SUBS2(NS)(1:6),PARAL2(IAL)
2008  FORMAT (' Parameter ',A4,' altered from ',A6,' to ',
     1A6)
      WRITE (2,2009)SUBS1(NS)(2:5),SUBS2(NS),PARAL2(IAL)
2009  FORMAT ('C   Parameter ',A4,' altered from ',A6,' to ',
     1A6)
C INCLUDE:  IF (INTER) ASK IF OK AND ALLOW RETYPING
      SUBS2(NS)=PARAL2(IAL)
      NSUB2(NS)=LINEND(SUBS2(NS),1,6)
      GO TO 43
C
C WE DEFINITELY WANT TO ASK USER FOR POSSIBLE NEW VALUE:
  47  IF (WORDY) WRITE(ITO,2010) SUBS1(NS)(2:5),SUBS2(NS)(1:6)
     1,MESS62(1:50)
2010  FORMAT (/' ',A4,' has default ',A6,
     1' for ',A50/ '     to CHANGE it type new value'/
     2'     to CONFIRM its default value type RETURN'/
     3'     or to QUIT altering any more parameters type Q : ')
      IF (.NOT. WORDY) WRITE (ITO,2510) SUBS1(NS)(2:5),
     1SUBS2(NS)(1:6),MESS62(1:50)
2510  FORMAT (/' ',A4,' has default ',A6,
     1' for ',A50    / ' type new value, RETURN to confirm or Q',
     2' to quit : ')
C
C USE SAME SPACE AS IF NON-INTERACTIVE:
      IAL=1
      READ (ITI,1004) PARAL2(1)
      LNAM=LINEND(PARAL2(1),1,6)
      IF (LNAM .EQ. 0) GO TO 43
      CALL UPONE(PARAL2(1),0)
      IF (LNAM .NE. 1 .OR. PARAL2(1) .NE. 'Q') GO TO 49
      ALTER=.FALSE.
      GO TO 43
C
C IGNORE MATERIAL UNTIL "COMM":
  44  NSUBS=NS-1
  17  READ (1,5000) LINE80
      IF (LINE80(1:4) .NE. 'COMM') GO TO 17
C
C READ IN COMMON BLOCKS WITH PARAMETERS:
      NCOMS=0
   6  READ (1,5000) LINE80
      ICO=IDGCHR(LINE80(2:2))
      I1=IDGCHR(LINE80(3:3))
      IF (I1 .GE. 0) ICO=10*ICO+I1
      IF (LINE80(1:1) .EQ. '-') ICO=-ICO
C THERE ARE ICO LINES IN NEXT BLOCK; 0 SIGNALS END:
      IF (ICO .EQ. 0) GO TO 10
C -VE ICO SIGNALS COMMENT LINES DESCRIBING CONTENTS OF COMMON:
      IF (ICO .GT. 0) GO TO 24
      DO 34 I=1,-ICO
      READ (1,5000) LINE80
  34  CONTINUE
      GO TO 6
  24  NCOMS=NCOMS+1
      IF (NCOMS .LE. NCOMM) GO TO 37
      WRITE (ITO,3002) NCOMM
3002  FORMAT (' More than',I5,' COMMONs')
      STOP
C
  37  IF (ICO .LE. NCLIN) GO TO 31
      WRITE (ITO,3003) NCLIN
3003  FORMAT (' More than',I5,' lines to a COMMON')
      STOP
C
  31  NCLINE(NCOMS)=ICO
      DO 11 I=1,ICO
      READ (1,5000) CTEXT(NCOMS,I)
C
C IF FIRST LINE, EXTRACT NAME:
      IF (I .NE. 1) GO TO 29
      DO 28 II=1,80
      IF (CTEXT(NCOMS,I)(II:II) .NE. '/') GO TO 28
      DO 27 JJ=1,6
      IF (CTEXT(NCOMS,I)(II+JJ:II+JJ) .EQ. '/') GO TO 29
      CNAME(NCOMS)(JJ:JJ)=CTEXT(NCOMS,I)(II+JJ:II+JJ)
  27  CONTINUE
      GO TO 29
  28  CONTINUE
C
C SUBSTITUTE FOR ANY SYMBOLIC PARAMETERS:
  29  LIND=LINEND(CTEXT(NCOMS,I),1,80)
      DO 16 K=1,NSUBS
      DO 15 L=1,LIND
      LFIN=L+NSUB1(K)-1
      IF (LFIN.GT.LIND) GO TO 16
      IF (CTEXT(NCOMS,I)(L:L+NSUB1(K)-1) .EQ. SUBS1(K)(1:NSUB1(K)))
     1 CALL SUBSTI(CTEXT(NCOMS,I),1,L,K,LIND)
  15  CONTINUE
  16  CONTINUE
  11  CONTINUE
      GO TO 6
C
C NOW WE ARE LOOKING FOR THE ACTUAL MATERIAL REQUESTED:
  10  WANT=.FALSE.
C IF SEPARATE HEADER FILE:
      IF (SEPHED) CLOSE(1)
      IF (SEPHED) CALL OPFILE(1,MASFIL,'OLD')
   1  READ(1,5000,END=7) LINE80
      IF (LINE80(1:1) .NE. '#') GO TO 8
      IF (LINE80(2:2) .NE. '#') GO TO 8
      IF ((WANT) .AND. (LINE80(3:5) .NE. 'END')) GO TO 8
      L=2
      IF (WANT) L=5
      IF (LINE80(L+1:L+3) .NE. PART3) GO TO 8
      WANT= .NOT. WANT
      GO TO 1
C
   8  IF (.NOT. WANT) GO TO 1
C
C IST POINTS TO LINE START - THERE ARE CIRCUMSTANCES IN WHICH IST MOVES ALONG:
      IST=1
      IF (LINE80(1:NCOMP1) .EQ. COMP6(1:NCOMP1)) THEN
        CALL OUTLIN(2,LINE80,1,NCOMP1)
        IST=IST+NCOMP1
      ELSE 
        DO 400 I=1,NOPT
        IF (LINE80(1:5) .EQ. OPSY6(I)(1:5)) THEN
          CALL OUTLIN(2,LINE80,1,NOPSY(I))
          IST=IST+NOPSY(I) 
          GO TO 401
        ENDIF
  400   CONTINUE     
  401   CONTINUE
      ENDIF
C
C DOES LINE START C- ?
      IF (LINE80(IST:IST) .NE. 'C' .OR. LINE80(IST+1:IST+1)
     1  .NE. '-') GO TO 88
      IF (LINE80(IST+2:IST+NCOMP1) .EQ. COMP6(2:NCOMP1)) GO TO 88
      IST1=6
      CALL OUTLIN(2,LINE80,1,IST1)
      IST=IST+IST1
C THIS ASSUMES THAT ALL COMP NAMES ARE 4 CHARACTERS:
C
C DOES LINE START WITH SLASH, FOR LABELLED COMMON?
  88  IF (LINE80(IST:IST) .NE. '/') GO TO 23
C DOES LINE START WITH SLASH, FOR LABELLED COMMON?
      CALL SUBCOM(LINE80,IST)
      GO TO 1
C
C NOW DO ALL PARAMETER SUBSTITUTIONS:
C ONLY TO LINES STARTING %
  23  LIND=LINEND(LINE80,IST,80)
      IF (LINE80(IST:IST) .NE. '%') GO TO 76
      CALL OUTLIN (2,'C%',1,2)
      LINE80(IST:IST)='C'
      CALL OUTLIN(2,LINE80,IST,LIND)
      IST=IST+1
      DO 13 J=1,NSUBS
      I=IST
      LFIN=LIND-NSUB1(J)+1
  14  IF (LINE80(I:I+NSUB1(J)-1) .EQ. SUBS1(J)(1:NSUB1(J)))
     1CALL SUBSTI(LINE80,IST,I,J,LIND)
      I=I+1
      IF (I .LE. LFIN) GO TO 14
  13  CONTINUE
  76  CALL OUTLIN(2,LINE80,IST,LIND)
      GO TO 1
C
C JOIN HERE IF EXISTING FILE TO BE USED:
   7  FIRST=.TRUE.
      FIRNEX=.FALSE.
  77  IF (.NOT. FIRST) GO TO 78
      REWIND 2
      IF (SPLIT) GO TO 95
      IF (WORDY) WRITE (ITO,2004) FILNAM
2004  FORMAT (/' Do you want to extract a routine or program',
     1' from ',A40/' Type its name if you do, or just',
     2' RETURN if not: ')
      IF (.NOT. WORDY) WRITE (ITO,2504)
2504  FORMAT (' Routine/program name or RETURN : ')
      GO TO 79
  78  IF (SPLIT) GO TO 95
      WRITE (ITO,2078)
2078  FORMAT (/' Another? Name or RETURN : ')
  79  READ (ITI,1004) ROUNAM
1004  FORMAT (A6)
      N=LINEND(ROUNAM,1,6)
      IF (N .EQ. 0) GO TO 12
      CALL UPONE(ROUNAM,NOPSYS)
      CALL DOTFOR(FIL1,ROUNAM,N,EXTEN)
C SEARCH NAME MUST BE UPPER CASE      
      CALL UPONE(ROUNAM,1)
  95  WOUND=.FALSE.
  20  IF (.NOT. FIRNEX) READ (2,5000,END=99) LINE80
      FIRNEX=.FALSE.
C READ UNTIL FIND "C LEVEL":
      IF (LINE80(1:7) .NE. 'C LEVEL') GO TO 20
C IF SPLITTING, WE WANT IT:
      IF (SPLIT) THEN
        LIND=LINEND(LINE80,1,80)
        LPAREN=0
        DO 91 I=LIND,1,-1
        IF (LINE80(I:I) .EQ. ')') THEN
          LPAREN=LPAREN+1
          GO TO 91
        ELSE IF (LINE80(I:I) .EQ. '(') THEN
          LPAREN=LPAREN-1
          GO TO 91
        ELSE IF (LINE80(I:I) .EQ. ' ') THEN
          GO TO 91
        ELSE IF (LPAREN .EQ. 0) THEN
          GO TO 92
        ENDIF
  91    CONTINUE
        STOP 'ERROR 1 IN FINDING ROUTINE NAME'
  92    DO 93 J=I,1,-1
        IF (LINE80(J:J) .EQ. ' ') GO TO 94
  93    CONTINUE
        STOP 'ERROR 2 IN FINDING ROUTINE NAME'
  94    ROUNAM=LINE80(J+1:I)
C GET THE CASE RIGHT FOR THE OPERATING SYSTEM
        CALL UPONE(ROUNAM,NOPSYS)
        CALL DOTFOR(FIL1,ROUNAM,N,EXTIN)
        GO TO 22
      ENDIF
C IT MAY NOT BE THE RIGHT "C LEVEL":
      DO 21 I=9,40
C IF FIND NAME OF ROUTINE SOMEWHERE AFTER THE "C LEVEL", WE WANT IT:
C *** NOT IF IT IS PCXX IN SUBROUTINE CALPR(PCXX, . . . WE DON'T
      IF (LINE80(I:I+N-1) .EQ. ROUNAM(1:N)) GO TO 41
  21  CONTINUE
C WRONG "C LEVEL":
      GO TO 20
C
C START OF REQUIRED ROUTINE;
  41  DO 45 J=1,26
      IF (LINE80(I+N:I+N) .EQ. UPLET(J)) GO TO 20
  45  CONTINUE
      IF (LINE80(I-1:I-1) .NE. ' ')GO TO 20
C
C ROUTINE NAME WAS PRECEDED BY A SPACE AND NOT FOLLOWED BY A LETTER:  
  22  IF (MACH .NE. 'VAX') CALL OPFILE(3,FIL1,'UNKNOWN') 
      IF (MACH .EQ. 'VAX') CALL OPFILE(3,FIL1,'NEW')
  25  LIND=LINEND(LINE80,1,80) 
      CALL OUTLIN(3,LINE80,1,LIND)
      READ (2,5000,END=42) LINE80
C WE END THE REQUIRED MATERIAL WITH "C LEVEL" ALSO;  THIS ALLOWS US TO
C KEEP A MAIN PROGRAM ALONG WITH SEVERAL SMALL SPECIFIC SUBROUTINES IF WE WISH
C (BY OMITTING THE "C LEVEL" FROM THEM)
      IF (LINE80(1:7) .EQ. 'C LEVEL') GO TO 42
C
C IF LINE SAYS JUST 'END', ARRANGE TO OMIT SUBSEQUENT COMMENT
C UNTIL EITHER "C LEVEL" OR THE START OF A NEW ROUTINE WHICH IS WANTED:
      IF ((LINE80(1:9) .NE. '      END') .OR. (LINEND(LINE80,1,80)
     1) .NE. 9) GO TO 25
      CALL OUTLIN(3,LINE80,1,9)
  55  READ (2,5000,END=42) LINE80
      IF (LINE80(1:7) .EQ. 'C LEVEL') GO TO 42
C
C IGNORE COMMENT LINES AFTER AN "END" IN CASE THEY ARE THE LAST 4:
      IF (LINE80(1:1) .EQ. 'C') GO TO 55
      CALL C4(3)
      GO TO 22
  42  CLOSE (3)
      FIRNEX=.TRUE.
      FIRST=.FALSE.
      GO TO 77
C
  99  IF (SPLIT) STOP
      IF (WOUND) GO TO 98
      WOUND=.TRUE.
      REWIND 2
      GO TO 20
C
  98  WRITE (ITO,3000)
3000  FORMAT (' Off end of input - no routine found')
      GO TO 7
C
C *** THIS PART WILL NEVER BE OBEYED, AS DEC10 HAS BEEN REMOVED FROM THE
C *** VOCABULARY.  BUT WE MAY JUST NEED IT ONE DAY.  IF A COMPUTER
C *** SUDDENLY ARISES WITH A ONE-PASS COMPILER/LOADER, MAKE IT ICOMP=2.
C IF A NEW FILE FOR DEC10, ASK IF WANT IT SHUFFLED:
  12  IF (NOTNEW .OR. ICOMP .NE. 2 .OR. IPART .EQ. 3
     1 .OR. IPART .EQ. 5) GO TO 100
      IF (WORDY) WRITE (ITO,2013)
2013  FORMAT (/' Do you want a file rearranged for a one-pass',
     1' compiler?'/' Type RETURN if not, or an entire NEW ',
     2'file name if wanted : ')
      IF (.NOT. WORDY) WRITE (ITO,2513)
2513  FORMAT (' File for sorted routines, or RETURN :')
      READ (ITI,1005) SHUFLE
1005  FORMAT (A10)
      N=LINEND(SHUFLE,1,10)
      IF (N .EQ. 0) GO TO 100
      CALL UPONE(SHUFLE,NOPSYS)
      DO 18 I=1,N
      IF (SHUFLE(I:I) .EQ. '.') GO TO 19
  18  CONTINUE
C IF USER GIVES NO EXTENSION, ADD .FOR
C-3084
      CALL DOTFOR (FIL1,SHUFLE,N,FOR)
      GO TO 26
  19  FIL1(1:N)=SHUFLE(1:N)
  26  CLOSE(4)
      IF (MACH .NE. 'VAX') CALL OPFILE(4,FIL1,'UNKNOWN')
      IF (MACH .EQ. 'VAX') CALL OPFILE(4,FIL1,'NEW')
C TO CONTROL 4CS BETWEEN ROUTINES:
      FOUND=.FALSE.
C
C SCAN LEVELS FROM 12 DOWNWARDS PICKING UP ROUTINES:
      DO 32 ILEV=1,12
      REWIND 2
      JLEV=13-ILEV
      CALL CHRINT(JLEV,NLEV,1,2)
      NC=2
      IF (JLEV .LT.10) NC=1
C
  33  READ(2,5000,END=32) LINE80
      IF (LINE80(1:7) .NE. 'C LEVEL') GO TO 33
C IS IT THE RIGHT C LEVEL FOR THIS J?
  39  IF (LINE80(9:8+NC) .NE. NLEV(1:NC)) GO TO 33
C AVOID 10 WHEN ONLY WANT 1:
      IF (LINE80(9+NC:9+NC) .NE. ' ') GO TO 33
C
C PUT OUT A "C LEVEL" - PRECEDED BY 4 CS UNLESS AT START:
      IF (FOUND) CALL C4(4)
      FOUND=.TRUE.
  36  LIND=LINEND(LINE80,1,80)
      CALL OUTLIN(4,LINE80,1,LIND)
      READ (2,5000,END=32) LINE80
      IF (LINE80(1:7) .EQ. 'C LEVEL') GO TO 39
C
C DEAL WITH 4 CS OFF END OF "END":
      IF ((LINE80(1:9) .NE. '      END') .OR. (LINEND(LINE80,1,80)
     1) .NE. 9) GO TO 36
      CALL OUTLIN(4,LINE80,1,9)
  38  READ (2,5000,END=32) LINE80
      IF (LINE80(1:7) .EQ. 'C LEVEL') GO TO 39
      IF (LINE80(1:1) .EQ. 'C') GO TO 38
      CALL C4(4)
      GO TO 36
C
  32  CONTINUE
 100  STOP
      END
C
C
C
C
      SUBROUTINE C4(IUNIT)
C
C WRITES FOUR EMPTY COMMENT LINES TO UNIT IUNIT
      DO 1 I=1,4
   1  WRITE (IUNIT,2000)
2000  FORMAT ('C')
      RETURN
      END
C
C
C
C
      CHARACTER *1 FUNCTION CHRDIG(N)
      CHARACTER *1 CHRS(10)
      COMMON /IOUNIT/ITO,ITI
      COMMON /SYSTYM/MANU,MACH,MON3,EXTEN,EXTIN
      CHARACTER *4 MANU,MACH
      CHARACTER *3 MON3,EXTEN,EXTIN
      DATA CHRS/'0','1','2','3','4','5','6','7','8','9'/
      CHRDIG=CHRS(N+1)
      RETURN
      END
C
C
C
C
      SUBROUTINE CHRINT(NINT,A,I,J)
      CHARACTER *1 CHRDIG
      CHARACTER *(*) A
      LOGICAL FRED
      COMMON /IOUNIT/ITO,ITI
      COMMON /SYSTYM/MANU,MACH,MON3,EXTEN,EXTIN
      CHARACTER *4 MANU,MACH
      CHARACTER *3 MON3,EXTEN,EXTIN
C
C PUT CHARACTERS OF THE INTEGER N INTO A, STARTING AT
C A(I:I) AND FILLING RHS WITH SPACES:
C
      N=NINT
      FRED=.FALSE.
      L=I
      IF (N) 1,2,3
   1  WRITE (ITO,3000) N
3000  FORMAT (' INTEGER ',I5,' SENT TO CHRINT')
      STOP
C
   3  M=100000
   5  IF (N .LT. M .AND. .NOT. FRED) GO TO 7
      FRED=.TRUE.
      K=N/M
      A(L:L)=CHRDIG(K)
      L=L+1
      N=N-K*M
   7  M=M/10
      IF (M .GT. 1) GO TO 5
C
   2  IF (L .LE. J) GO TO 6
      WRITE (ITO,3000) N
      STOP
C
   6   A(L:L) = CHRDIG(N)
      IF (L .GE. J) GO TO 100
      DO 4 II=L+1,J
   4  A(II:II)=' '
 100  RETURN
      END
C
C
C
C
      SUBROUTINE DOTFOR(FILE,START,L1,EXT)
      CHARACTER *40 FILE
      CHARACTER *6 START
      CHARACTER *3 EXT
      COMMON /IOUNIT/ITO,ITI
      COMMON /SYSTYM/MANU,MACH,MON3,EXTEN,EXTIN
      CHARACTER *4 MANU,MACH
      CHARACTER *3 MON3,EXTEN,EXTIN
C
      IF (MANU .EQ. 'DEC') THEN
      J=7
   1  IF (J .EQ. 1) GO TO 3
      J=J-1
      IF (START(J:J) .EQ. ' ') GO TO 1
   3  FILE(1:J)=START(1:J)
      FILE(J+1:)='.'//EXT
      ELSE
      FILE(1:5)='JCM1.'
      FILE(6:)=START(1:L1)
      ENDIF
      RETURN
      END
C
C
C
C
      FUNCTION IDGCHR(C)
      CHARACTER *1 C
      CHARACTER *1 CHRS(11)
      COMMON /IOUNIT/ITO,ITI
      DATA CHRS /' ','0','1','2','3','4','5','6','7','8','9'/
C
      DO 1 I=1,11
      IF (C .EQ. CHRS(I)) GO TO 101
   1  CONTINUE
      WRITE (ITO,3000) C
3000  FORMAT (1X,A1,' is not the character for a digit or space')
      STOP
 101  IDGCHR=I-2
      RETURN
      END
C
C
C
C
      FUNCTION INTCHR(A,J)
      CHARACTER *(*) A
C SET INTCHR TO BE THE INTEGER REPRESENTED IN A, STARTING AT A(1:1):
C
      LOGICAL FRED
      COMMON /IOUNIT/ITO,ITI
      N=0
      FRED=.FALSE.
      DO 1 K=1,J
      M=IDGCHR(A(K:K))
      IF (M .LT. 0 .AND. .NOT. FRED) GO TO 1
C
      IF (M .LT. 0) GO TO 101
      FRED=.TRUE.
      N=10*N+M
   1  CONTINUE
C
 101  INTCHR=N
      RETURN
      END
C
C
C
C
      FUNCTION LENGT(CHAR)
C
C *** LENGT BY JCM 13 NOV 87 ***
C
CC 16C
CH Determines length of character variable, omitting final spaces
CA On entry, CHAR is a character variable
C
      CHARACTER*(*) CHAR
C
      I=LEN(CHAR)+1
   1  I=I-1
      IF (I .LE. 0) GO TO 101
      IF (CHAR(I:I) .EQ. ' ') GO TO 1
  101 LENGT=I
  100 RETURN
      END
C
C
C
C
      FUNCTION LINEND(LINE80,IST,IEND)
      CHARACTER *(*) LINE80
      COMMON /IOUNIT/ITO,ITI
C
C TAKES AS INPUT LINE WHICH IS A *(*) BUFFER, AND IST WHICH IS WHERE  TO
C START IN IT, AND IEND WHICH IS WHERE TO FINISH
C
C SETS LINEND TO POINT TO THE LAST NON-SPACE.
C
      DO 1 I=IST,IEND
      J=IEND+IST-I
      IF (LINE80(J:J) .NE. ' ') GO TO 101
   1  CONTINUE
      J=0
 101  LINEND=J
      RETURN
      END
C
C
C
C
      SUBROUTINE OPFILE(N,FILNAM,STAT)
C
C OPEN UNIT N, FILE NAMED FILNAM, STATUS STAT:
C
      CHARACTER *(*) FILNAM
      CHARACTER *(*) STAT
      COMMON /SYSTYM/MANU,MACH,MON3,EXTEN,EXTIN
      CHARACTER *4 MANU,MACH
      CHARACTER *3 MON3,EXTEN,EXTIN
C
C *************** IF RUNNING ON IBM REMOVE ALL THIS LOT EXCEPT
C        THE SIMPLE "OPEN" BELOW AND THE "RETURN" AND "END"
C****************************************************************
C
      IF (STAT .EQ. 'NEW') THEN
      OPEN (N,FILE=FILNAM,STATUS=STAT,RECL=80,
     1ACCESS='SEQUENTIAL',CARRIAGECONTROL='LIST')
      ELSE IF (STAT .EQ. 'OLD') THEN
      OPEN (N,FILE=FILNAM,STATUS=STAT,RECL=80,
     1ACCESS='SEQUENTIAL',READONLY)
      ELSE
C THIS IS THE "SIMPLE OPEN" TO ** LEAVE HERE ** FOR IBM:
      OPEN (N,FILE=FILNAM,STATUS=STAT,ACCESS='SEQUENTIAL',RECL=80)
      ENDIF
      RETURN
      END
C
C
C
C
      SUBROUTINE OUTLIN(IUNIT,LINE80,IST,LIND)
      CHARACTER *(*)LINE80
      COMMON /IOUNIT/ITO,ITI
C
C TAKES AS INPUT A LINE OF CHARACTERS IN LINE80, AND OUTPUTS
C IT BETWEEN IST AND LIND INCLUSIVE.  ALLOWS LIND=0 FOR EMPTY LINES.
C
      IF (IUNIT .EQ. 1) THEN
        WRITE (ITO,3002)
3002    FORMAT (' HANDS OFF THE MISTRE.SS FILE!')
        STOP
      ENDIF
      IF (LIND .EQ. 0) THEN
        WRITE (IUNIT,2000)
      ELSE
        IF (LIND .GT.73) THEN
          IF (LINE80(1:1) .EQ. ' ' .AND. LINE80(73:LIND) .NE. ' ') THEN
            WRITE (ITO,3000) LINE80
3000        FORMAT (' WARNING - LONG LINE:'/A80)
          ENDIF
        ENDIF
        WRITE (IUNIT,2000) LINE80(IST:LIND)
2000    FORMAT (A)
      ENDIF
      RETURN
      END
C
C
C
C
      SUBROUTINE SUBCOM(LINE80,IST)
      PARAMETER (NPARS=200,NCOMM=150,NCLIN=7)
      CHARACTER *80  LINE80
      CHARACTER *1 KCH1,KCH2
      CHARACTER *20 TEMP
      COMMON /IOUNIT/ITO,ITI
C
C TAKES AS INPUT A STRING IN LINE80 WHICH STARTS WITH A SLASH
C EXPECTS THEREFORE TO MEET A NAME OF A COMMON BLOCK AND ANOTHER SLASH.
C
C IDENTIFIES THE NAME, AND WRITES OUT THE APPROPRIATE NUMBER OF LINES OF
C COMMON BLOCK, AS FORMED EARLIER IN THE ARRAY CTEXT.
      COMMON /COMSUB/NCOMS,NCLINE(NCOMM)
      COMMON /COMSUC/CNAME(NCOMM),CTEXT(NCOMM,NCLIN)
      CHARACTER *6 CNAME
      CHARACTER *80 CTEXT
C
C FIRST FIND SECOND SLASH:
      K=1
   2  K=K+1
      IF (LINE80(K+IST-1:K+IST-1) .NE. '/' .AND. LINE80(K+IST-1
     1:K+IST-1) .NE. ' ') GO TO 2
      K=K-2
C K NOW NUMBER OF LETTERS IN COMMON NAME
C
C SCAN NAMES AND MATCH:
      DO 1 I=1,NCOMS
      IF (LINE80(IST+1:IST+K) .NE. CNAME(I)(1:K)) GO TO 1
      N1=NCLINE(I)
      DO 3 J=1,N1
      L=LINEND(CTEXT(I,J),1,80)
   3  CALL OUTLIN(2,CTEXT(I,J),1,L)
C
C IF + AFTER SECOND /, WANT 2 MORE LINES FOR DUMPING:
      IF (LINE80(IST+K+2:IST+K+2) .NE. '+') GO TO 100
C KOM WILL COLLECT WHICH COMMON NUMBER IT IS:
      KOM=0
  89  IF (N1 .EQ. 1 .OR. CTEXT(I,N1)(6:6) .NE. ' ') GO TO 88
      N1=N1-1
      GO TO 89
C
C N1=LAST LINE OF ACTUAL COMMON DECLARATION:
  88  L=LINEND(CTEXT(I,N1),1,80)
      IF (CTEXT(I,N1)(L-3:L-1) .EQ. 'KOM') THEN
        KCH1=CTEXT(I,N1)(L:L)
        KCH2=' '
        KOM=1
      ENDIF
      IF (CTEXT(I,N1)(L-4:L-2) .EQ. 'KOM') THEN
        KOM=2
        KCH2=CTEXT(I,N1)(L:L)
        KCH1=CTEXT(I,N1)(L-1:L-1)
      ENDIF
      IF (KOM .EQ. 0) GO TO 100
C KOMN FOUND - SCAN FIRST ELEMENT OF COMMON TO BE EQUIVALENCED:
      IPT=12
      ISLSH=0
  81  IPT=IPT+1
C FIND BOTH /S:
      IF (CTEXT(I,1)(IPT:IPT) .EQ. '/') ISLSH=ISLSH+1
      IF (ISLSH .NE. 2) GO TO 81
C
C START OF FIRST ITEM:
      I1=IPT+1
C SET 'THIS IS NOT AN ARRAY'
      IARR=0
  83  IPT=IPT+1
C IF COMMA BEFORE ( MUST BE END:
      IF (CTEXT(I,1)(IPT:IPT) .EQ. ',' .AND. IARR .EQ. 0) GO TO 82
C CATER FOR COMMON WITH ONLY ONE ITEM AND THEREFORE NO COMMA:
      IF (CTEXT(I,1)(IPT:IPT) .EQ. ' ' .AND. IARR .EQ. 0) GO TO 82
C ) MUST BE END OF ITEM:
      IF (CTEXT(I,1)(IPT:IPT) .EQ. ')') THEN
        IPT=IPT+1
        GO TO 82
      ENDIF
C ( MEANS IT MUST BE AN ARRAY:
      IF (CTEXT(I,1)(IPT:IPT) .EQ. '(') IARR=IPT+1
      GO TO 83
C
C WRITE OUT DIMENSION & EQUIVALENCE STATEMENTS:
  82  LINE80='      DIMENSION KOMM'//KCH1//KCH2//'(1)'
      CALL OUTLIN(2,LINE80,1,25)
      TEMP=CTEXT(I,1)(I1:IPT-1)
      IF (IARR .EQ. 0) GO TO 85
      IARR=IARR-I1+1
  87  TEMP(IARR:IARR)='1'
  86  IARR=IARR+1
      IF (TEMP(IARR:IARR) .EQ. ')') GO TO 85
      IF (TEMP(IARR:IARR) .EQ. ',') THEN
        IARR=IARR+1
        GO TO 87
      ENDIF
      TEMP(IARR:IARR) = ' '
      GO TO 86
  85  LINE80='      EQUIVALENCE (KOMM'//KCH1//KCH2//'(1),'//
     1TEMP(1:IPT-I1)//')'
      CALL OUTLIN(2,LINE80,1,50)
      GO TO 100
   1  CONTINUE
      WRITE (ITO,3000) LINE80(IST+1:IST+K)
3000  FORMAT (' ERROR - CANNOT FIND COMMON ',A6)
 100  RETURN
      END
C
C
C
C
      SUBROUTINE SUBSTI(LINE80,IST,IN,J,LIND)
      PARAMETER (NPARS=200,NCOMM=150,NCLIN=7)
      CHARACTER *80 LINE80,LTEMP
      COMMON /IOUNIT/ITO,ITI
      COMMON /PARSUB/NSUBS,NSUB1(NPARS),NSUB2(NPARS)
      COMMON /PARSUC/SUBS1(NPARS),SUBS2(NPARS)
      CHARACTER *6 SUBS1,SUBS2
C
C TAKES AS INPUT A LINE IN LINE80, WHICH BEGINS
C AT POSITION IST AND ENDS AT LIND.  AT POSITION "IN" THERE IS THE START
C OF A STRING WHICH IT IS REQUIRED TO REPLACE BY ANOTHER STRING.
C THE STRING IS NUMBER J IN THE PARAMETER SUBSTITUTION TABLE.
C
      I1=IN-1
C COPY UP TO CHANGED PART:
      IF (I1 .LT. IST) GO TO 3
C LEAVE UNUSED FIRST PART OF LTEMP
      LTEMP(IST:I1)=LINE80(IST:I1)
C
C SUBSTITUTE STRING - THE LENGTHS OF THE OLD AND THE NEW STRINGS ARE IN
C NSUB1(J) AND NSUB2(J) RESPECTIVELY.
   3  I2=NSUB2(J)+IN-1
      LTEMP(IN:I2)=SUBS2(J)(1:NSUB2(J))
C
C COPY REST OF UNCHANGED SOURCE:
      I3=NSUB1(J)+IN
      IF (I3 .GT. LIND) GO TO 6
      K=I2
      DO 4 I=I3,LIND
      K=K+1
   4  LTEMP(K:K)=LINE80(I:I)
   6  LIND=LIND-NSUB1(J)+NSUB2(J)
      LINE80=' '
      LINE80(IST:LIND)=LTEMP(IST:LIND)
 100  RETURN
      END
C
C
C
C
      SUBROUTINE UPONE(CH,ISYS)
C TO LOWER CASE FOR UNIX UPPER FOR VMS     
      CHARACTER *(*) CH
      CHARACTER *1 UPLET(26),LOLET(26)
      DATA UPLET/'A','B','C','D','E','F','G','H','I','J','K','L',
     1'M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/
      DATA LOLET/'a','b','c','d','e','f','g','h','i','j','k','l',
     1'm','n','o','p','q','r','s','t','u','v','w','x','y','z'/
      N=LEN(CH)
      DO 1 I=1,N
      DO 2 J=1,26
C UNIX NEEDS LOWER CASE
      IF (ISYS.EQ.3) THEN
        IF (CH(I:I) .NE. UPLET(J)) GO TO 2
        CH(I:I)=LOLET(J)
      ELSE
        IF (CH(I:I) .NE. LOLET(J)) GO TO 2
        CH(I:I)=UPLET(J)
      ENDIF
      GO TO 1
   2  CONTINUE
   1  CONTINUE
      RETURN
      END
